# $Revision: 1.80 $, $Date: 2011/11/28 00:22:53 $
%define		snap	20111127
Summary:	PLD RPM builder environment
Summary(pl.UTF-8):	Środowisko budowniczego pakietów RPM dla PLD
Name:		pld-builder
Version:	0.5.%{snap}
Release:	1
License:	GPL
Group:		Development/Building
Source0:	%{name}-%{version}.tar.bz2
# Source0-md5:	e9aeb082ad8f2b7d653b24a17ef87b7f
Source1:	%{name}.init
Source2:	%{name}.sysconfig
Source3:	poldek.conf
Source4:	rpm.macros
Source5:	crontab
Source6:	procmailrc
Source7:	sudo
URL:		http://cvs.pld-linux.org/cgi-bin/cvsweb/pld-builder.new/
BuildRequires:	python
BuildRequires:	rpm-pythonprov
BuildRequires:	rpmbuild(macros) >= 1.469
BuildRequires:	sed >= 4.0
Requires(post,preun):	/sbin/chkconfig
Requires(postun):	/usr/sbin/userdel
Requires(pre):	/bin/id
Requires(pre):	/usr/bin/getgid
Requires(pre):	/usr/sbin/groupadd
Requires(pre):	/usr/sbin/useradd
Requires:	/usr/lib/sendmail
Requires:	bash
Requires:	bzip2
Requires:	crondaemon
Requires:	filesystem >= 3.0-33
Requires:	gnupg
Requires:	libuuid
Requires:	python
Requires:	python-pld-builder = %{version}-%{release}
Requires:	rc-scripts
Requires:	rsync
Requires:	sudo
Provides:	group(builder)
Provides:	user(builder)
BuildArch:	noarch
BuildRoot:	%{tmpdir}/%{name}-%{version}-root-%(id -u -n)

%define		_sysconfdir	/etc/pld-builder
%define		_datadir	/usr/share/%{name}

%description
PLD RPM builder environment. This is the freshest "new" builder.

Other new and older attempts can be found from:
http://cvs.pld-linux.org/cgi-bin/cvsweb/pld-builder/
http://cvs.pld-linux.org/cgi-bin/cvsweb/pld-builder.old/
http://cvs.pld-linux.org/cgi-bin/cvsweb/builder_ng/

%description -l pl.UTF-8
Środowisko budowniczego pakietów RPM dla PLD. To jest najnowszy "nowy"
builder.

Inne nowe i starsze próby można znaleźć pod:
http://cvs.pld-linux.org/cgi-bin/cvsweb/pld-builder/
http://cvs.pld-linux.org/cgi-bin/cvsweb/pld-builder.old/
http://cvs.pld-linux.org/cgi-bin/cvsweb/builder_ng/

%package -n python-pld-builder
Summary:	PLD Builder
Summary(pl.UTF-8):	Budowniczy PLD
Group:		Development/Building
%pyrequires_eq	python-modules

%description -n python-pld-builder
PLD Builder Python code.

%description -n python-pld-builder -l pl.UTF-8
Kod pythonowy budowniczego PLD.

%package chroot
Summary:	PLD Builder chroot
Summary(pl.UTF-8):	Środowisko chroot buildera PLD
Group:		Development/Building
Requires(postun):	/usr/sbin/userdel
Requires(pre):	/bin/id
Requires(pre):	/usr/bin/getgid
Requires(pre):	/usr/sbin/groupadd
Requires(pre):	/usr/sbin/useradd
Requires:	bash
Requires:	filesystem >= 3.0-33
Requires:	mount
Requires:	poldek >= 0.21-0.20070703.00.16
Requires:	rpm-build
Requires:	tmpwatch
# NOTE: vserver-packages is usually hidden, so you must install it manually with --noignore
Requires:	basesystem
Requires:	vserver-packages
Provides:	group(builder)
Provides:	user(builder)
# for srpm builder
Requires:	cvs-client
Requires:	rpm-build-tools

%description chroot
This is the package to be installed in builder chroot.

%description chroot -l pl.UTF-8
Ten pakiet należy zainstalować w środowisku chroot buildera.

%prep
%setup -q
%{__sed} -i -e '
	/^root_dir/s,=.*,= "%{_sharedstatedir}/%{name}",
	/^conf_dir/s,=.*,= "%{_sysconfdir}",
' PLD_Builder/path.py

%{__sed} -i -e '
	s,pld-linux\.org,example.org,g
	s,/spools/ready,/var/cache/%{name}/ready,
' config/builder.conf

%build
%{__make}
%py_lint PLD_Builder

%install
rm -rf $RPM_BUILD_ROOT

# python
install -d $RPM_BUILD_ROOT%{py_scriptdir}/PLD_Builder
cp -p PLD_Builder/*.py[co] $RPM_BUILD_ROOT%{py_scriptdir}/PLD_Builder

# other
install -d $RPM_BUILD_ROOT%{_sysconfdir}
cp -p config/{rsync-passwords,*.conf} $RPM_BUILD_ROOT%{_sysconfdir}
install -d $RPM_BUILD_ROOT%{_datadir}/{bin,admin}
for a in bin/*.sh; do
sed -e '
	/cd ~\/pld-builder.new/d
	s,python \(PLD_Builder.*.py\),python %{py_scriptdir}/\1c,
' $a > $RPM_BUILD_ROOT%{_datadir}/bin/$(basename $a)
done
cp -a admin/*.sh $RPM_BUILD_ROOT%{_datadir}/admin

# dirs
install -d $RPM_BUILD_ROOT{%{_sharedstatedir}/%{name}/{spool/{buildlogs,builds,ftp,notify},lock},/etc/{sysconfig,rc.d/init.d}}
install -d $RPM_BUILD_ROOT/home/services/builder/.gnupg
install -d $RPM_BUILD_ROOT/home/services/builder/.ssh
install -d $RPM_BUILD_ROOT/home/services/builder/rpm/{BUILD,RPMS,SRPMS,SPECS,SOURCES,packages/CVS}
install -d $RPM_BUILD_ROOT/var/cache/%{name}/ready
ln -s %{_bindir}/builder $RPM_BUILD_ROOT/home/services/builder/rpm/packages

echo "packages" > $RPM_BUILD_ROOT/home/services/builder/rpm/packages/CVS/Repository
echo ":pserver:cvs@cvs.pld-linux.org:/cvsroot" > $RPM_BUILD_ROOT/home/services/builder/rpm/packages/CVS/Root
touch $RPM_BUILD_ROOT/home/services/builder/rpm/packages/CVS/Entries{,.Static}

install -d $RPM_BUILD_ROOT/etc/poldek/repos.d
cp -p %{SOURCE3} $RPM_BUILD_ROOT/etc/poldek/repos.d/%{name}.conf

install -d $RPM_BUILD_ROOT/etc/rpm
cp -p %{SOURCE4} $RPM_BUILD_ROOT/etc/rpm/macros.builder

# crontab
install -d $RPM_BUILD_ROOT/etc/cron.d
cp -p %{SOURCE5} $RPM_BUILD_ROOT/etc/cron.d/%{name}

# sudo
install -d $RPM_BUILD_ROOT/etc/sudoers.d
cp -p %{SOURCE7} $RPM_BUILD_ROOT/etc/sudoers.d/%{name}

install -p %{SOURCE1} $RPM_BUILD_ROOT/etc/rc.d/init.d/pld-builder
cp -p %{SOURCE2} $RPM_BUILD_ROOT/etc/sysconfig/pld-builder

# from admin/fresh-queue.sh
cd $RPM_BUILD_ROOT%{_sharedstatedir}/%{name}
install -d spool/{builds,buildlogs,notify,ftp} lock
echo 0 > spool/last_req_no
echo -n > spool/processed_ids
echo -n > spool/got_lock
echo '<queue/>' > spool/queue
echo '<queue/>' > spool/req_queue
if [ "$binary_builders" ]; then
	for bb in $binary_builders; do
		echo '<queue/>' > spool/queue-$bb
	done
fi

%clean
rm -rf $RPM_BUILD_ROOT

%pre
%groupadd -g 181 builder
%useradd -u 182 -g builder -c "bin builder" -s /bin/bash -d /home/services/builder builder

%pre chroot
%groupadd -g 181 builder
%useradd -u 182 -g builder -c "bin builder" -s /bin/bash -d /home/services/builder builder

%post
/sbin/chkconfig --add %{name}

%preun
if [ "$1" = "0" ]; then
	%service %{name} stop
	/sbin/chkconfig --del %{name}
fi

%postun
if [ "$1" = "0" ]; then
	%userremove builder
	%groupremove builder
fi

%postun chroot
if [ "$1" = "0" ]; then
	%userremove builder
	%groupremove builder
fi

%files
%defattr(644,root,root,755)
%doc README TODO
%doc user-manual.txt
%lang(pl) %doc jak-to-dziala.txt jak-wysylac-zlecenia.txt

%attr(754,root,root) /etc/rc.d/init.d/pld-builder
%attr(640,root,root) %config(noreplace) %verify(not md5 mtime size) /etc/sysconfig/pld-builder

%attr(640,root,root) %config(noreplace) %verify(not md5 mtime size) /etc/cron.d/%{name}
%attr(640,root,root) %config(noreplace) %verify(not md5 mtime size) /etc/sudoers.d/%{name}

%dir %{_sysconfdir}
%attr(640,root,builder) %config(noreplace) %verify(not md5 mtime size) %{_sysconfdir}/*.conf
%attr(640,root,builder) %config(noreplace) %verify(not md5 mtime size) %{_sysconfdir}/rsync-passwords

%dir %{_datadir}
%dir %{_datadir}/bin
%attr(755,root,root) %{_datadir}/bin/*
%dir %{_datadir}/admin
%attr(755,root,root) %{_datadir}/admin/*

%dir %{_sharedstatedir}/%{name}

%dir %attr(775,root,builder) %{_sharedstatedir}/%{name}/spool
%dir %attr(775,root,builder) %{_sharedstatedir}/%{name}/spool/buildlogs
%dir %attr(775,root,builder) %{_sharedstatedir}/%{name}/spool/builds
%dir %attr(775,root,builder) %{_sharedstatedir}/%{name}/spool/ftp
%dir %attr(775,root,builder) %{_sharedstatedir}/%{name}/spool/notify

%attr(644,builder,builder) %config(noreplace) %verify(not md5 mtime size) %{_sharedstatedir}/%{name}/spool/got_lock
%attr(644,builder,builder) %config(noreplace) %verify(not md5 mtime size) %{_sharedstatedir}/%{name}/spool/last_req_no
%attr(644,builder,builder) %config(noreplace) %verify(not md5 mtime size) %{_sharedstatedir}/%{name}/spool/processed_ids
%attr(644,builder,builder) %config(noreplace) %verify(not md5 mtime size) %{_sharedstatedir}/%{name}/spool/queue
%attr(644,builder,builder) %config(noreplace) %verify(not md5 mtime size) %{_sharedstatedir}/%{name}/spool/req_queue

%dir %attr(775,root,builder) %{_sharedstatedir}/%{name}/lock

%dir %attr(750,builder,builder) /home/services/builder
%dir %attr(750,builder,builder) /home/services/builder/.gnupg
%dir %attr(700,builder,builder) /home/services/builder/.ssh

%files chroot
%defattr(644,root,root,755)
%dir %attr(750,builder,builder) /home/services/builder
%dir %attr(750,builder,builder) /home/services/builder/rpm
%dir %attr(750,builder,builder) /home/services/builder/rpm/BUILD
%dir %attr(750,builder,builder) /home/services/builder/rpm/RPMS
%dir %attr(750,builder,builder) /home/services/builder/rpm/SRPMS
%dir %attr(750,builder,builder) /home/services/builder/rpm/SPECS
%dir %attr(750,builder,builder) /home/services/builder/rpm/SOURCES
%dir %attr(750,builder,builder) /home/services/builder/rpm/packages

# for srpm builder
%attr(750,builder,builder) /home/services/builder/rpm/packages/builder
%dir %attr(750,builder,builder) /home/services/builder/rpm/packages/CVS
%attr(640,builder,builder) %config(noreplace) %verify(not md5 mtime size) /home/services/builder/rpm/packages/CVS/Repository
%attr(640,builder,builder) %config(noreplace) %verify(not md5 mtime size) /home/services/builder/rpm/packages/CVS/Root
%attr(640,builder,builder) %config(noreplace) %verify(not md5 mtime size) /home/services/builder/rpm/packages/CVS/Entries
%attr(640,builder,builder) %config(noreplace) %verify(not md5 mtime size) /home/services/builder/rpm/packages/CVS/Entries.Static

# minimal but sane defaults for rpm inside chroot
%config(noreplace) %verify(not md5 mtime size) /etc/rpm/macros.builder

# locally cached rpms from bin-builder
%config(noreplace) %verify(not md5 mtime size) /etc/poldek/repos.d/%{name}.conf
%dir /var/cache/%{name}
%dir %attr(775,root,builder) /var/cache/%{name}/ready

%files -n python-pld-builder
%defattr(644,root,root,755)
%{py_scriptdir}/PLD_Builder

%define date	%(echo `LC_ALL="C" date +"%a %b %d %Y"`)
%changelog
* %{date} PLD Team <feedback@pld-linux.org>
All persons listed below can be reached at <cvs_login>@pld-linux.org

$Log: pld-builder.spec,v $
Revision 1.80  2011/11/28 00:22:53  glen
- build logs are compressed with bzip2

Revision 1.79  2011/11/28 00:01:02  glen
- add sudoers rule

Revision 1.78  2011/11/27 21:31:43  glen
- 20111127 snap

Revision 1.77  2010/12/28 13:39:00  glen
- move heredocs to individual source files

Revision 1.76  2010/12/28 13:33:21  glen
- type=dir poldek indexes not updateable
- new snap

Revision 1.75  2010/11/11 17:15:51  glen
- release 3

Revision 1.74  2010/11/11 16:33:35  glen
- builder code assumes old rpm/SPECS, rpm/SOURCES structure, make dirs

Revision 1.73  2010/11/11 16:30:21  glen
- refresh snapshot

Revision 1.72  2010/11/11 16:28:15  glen
- require /home/services world readable

Revision 1.71  2010/09/01 15:06:40  glen
- release 2

Revision 1.70  2010/09/01 14:21:49  glen
- md5

Revision 1.69  2010/09/01 11:32:14  glen
- current snap (20100901)

Revision 1.68  2010/05/09 17:10:27  glen
- 20100509 snap

Revision 1.67  2010/01/22 17:47:59  glen
- 20100122 snap, drop src builder dirs

Revision 1.66  2010/01/21 19:59:48  glen
- sendmail dep for builder
- do not restart pld-builder service on upgrade (mounting and umounting /proc is pointless)
- make configs private
- rel 3

Revision 1.65  2010/01/21 13:40:18  glen
- new dir stricture; rel 2

Revision 1.64  2010/01/21 13:34:02  glen
- v0.5 snap, base req sudo

Revision 1.63  2009/05/25 12:16:52  glen
- 0.4.20090525 snap

Revision 1.62  2009/04/08 07:19:08  glen
- new snap

Revision 1.61  2009/04/07 07:09:17  glen
- builder R: rsync

Revision 1.60  2009/04/06 15:00:25  glen
- err, uploaded to df

Revision 1.59  2009/04/06 14:53:11  glen
- fresh snap

Revision 1.58  2009/03/30 13:52:15  glen
- blah, distfiles is down

Revision 1.57  2009/03/30 13:48:12  glen
- fresh snap (20090330)

Revision 1.56  2009/02/06 02:35:32  glen
- release 0.2

Revision 1.55  2009/02/06 02:34:53  glen
- v0.3

Revision 1.54  2009/02/06 02:31:01  glen
- chroot R mount (for /proc) for java builds
- add procmailrc

Revision 1.53  2008/10/29 01:11:58  glen
- addons to get srpm builder rolling

Revision 1.52  2008/10/28 23:58:10  glen
- fix crontab install

Revision 1.51  2008/10/28 23:36:13  glen
- remove srpms_builder, ftpac those are on ep09
- add system crontab

Revision 1.50  2008/08/25 18:23:32  glen
- rpm macros for chroot

Revision 1.49  2008/08/25 18:12:35  glen
- tmpwatch to chroot

Revision 1.48  2008/08/13 12:22:13  glen
- update to 0.2

Revision 1.47  2008/07/17 17:25:31  glen
- R: python

Revision 1.46  2008/07/17 16:04:26  glen
- make rpm_cache_dir=/spools/ready configurable

Revision 1.45  2008/07/17 14:09:47  glen
- add cache dir for rpms from bin builder

Revision 1.44  2008/07/17 13:47:07  glen
- use tarball from make dist
- version 0.1
- -client dropped as make-request.spec exists

Revision 1.43  2008/07/17 12:44:26  glen
- new snap (20080717), check python syntax

Revision 1.42  2008/07/17 10:00:36  glen
- use bash for builder shell

Revision 1.41  2008/07/15 17:46:14  qboosh
- pl for -chroot

Revision 1.40  2008/07/15 12:47:36  glen
- dirs and permissions

Revision 1.39  2008/07/15 11:27:22  glen
- need gnupg at runtime

Revision 1.38  2008/07/15 10:20:06  glen
- add chroot pkg

Revision 1.37  2008/07/15 10:00:51  glen
- init structure using code from admin/fresh-queue.sh

Revision 1.36  2008/07/14 16:37:04  glen
- update deps

Revision 1.35  2008/07/13 18:53:42  glen
- BR rpm-pythonprov

Revision 1.34  2008/07/13 18:52:46  glen
- fix md5

Revision 1.33  2008/07/13 18:47:57  glen
- new snap (20080713)

Revision 1.32  2008/07/13 18:46:07  glen
- few perms, pld-builder group

Revision 1.31  2008/06/25 20:58:32  glen
- use us-ascii for filenames

Revision 1.30  2008/06/25 20:48:33  glen
- new snap (20080625)

Revision 1.29  2007-02-13 08:06:41  glen
- tabs in preamble

Revision 1.28  2007/02/12 01:06:26  baggins
- converted to UTF-8

Revision 1.27  2007/01/22 11:27:30  glen
- reallocate uids

Revision 1.26  2007/01/22 11:23:51  glen
- R: libuuid for uuidgen
- create users

Revision 1.25  2006/04/23 17:21:06  glen
- macros for service

Revision 1.24  2006/04/20 17:14:41  glen
- fix chkconfig deps

Revision 1.23  2006/04/03 16:00:24  twittner
- added initscript (template) for performing administrator's tasks
  for pld-builder such as mounting /proc in builder chroots,
  installing/removing crontables for non-standalone builders

Revision 1.22  2005/11/03 00:29:18  qboosh
- updated pl

Revision 1.21  2005/11/01 20:24:20  glen
- md5

Revision 1.20  2005/11/01 20:11:15  glen
- typos, more dirs

Revision 1.19  2005/11/01 20:00:27  glen
- more something

Revision 1.18  2005/11/01 19:22:34  glen
- adding, once again. written from scratch. not started yet
